[comment]: <> (Code generated by mdatagen. DO NOT EDIT.)

# rabbitmq

## Default Metrics

The following metrics are emitted by default. Each of them can be disabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: false
```

### rabbitmq.consumer.count

The number of consumers currently reading from the queue.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {consumers} | Sum | Int | Cumulative | false |

### rabbitmq.message.acknowledged

The number of messages acknowledged by consumers.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {messages} | Sum | Int | Cumulative | true |

### rabbitmq.message.current

The total number of messages currently in the queue.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {messages} | Sum | Int | Cumulative | false |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| state | The state of messages in a queue. | Str: ``ready``, ``unacknowledged`` |

### rabbitmq.message.delivered

The number of messages delivered to consumers.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {messages} | Sum | Int | Cumulative | true |

### rabbitmq.message.dropped

The number of messages dropped as unroutable.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {messages} | Sum | Int | Cumulative | true |

### rabbitmq.message.published

The number of messages published to a queue.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {messages} | Sum | Int | Cumulative | true |

## Optional Metrics

The following metrics are not emitted by default. Each of them can be enabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: true
```

### rabbitmq.node.channel_closed

Number of channels closed.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {channels} | Sum | Int | Cumulative | false |

### rabbitmq.node.channel_closed_details.rate

Rate of channels closed.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {channels}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.channel_created

Number of channels created.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {channels} | Sum | Int | Cumulative | false |

### rabbitmq.node.channel_created_details.rate

Rate of channels created.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {channels}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.connection_closed

Number of connections closed.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {connections} | Sum | Int | Cumulative | false |

### rabbitmq.node.connection_closed_details.rate

Rate of connections closed.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {connections}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.connection_created

Number of connections created.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {connections} | Sum | Int | Cumulative | false |

### rabbitmq.node.connection_created_details.rate

Rate of connections created.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {connections}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.context_switches

Total number of context switches.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {switches} | Sum | Int | Cumulative | false |

### rabbitmq.node.context_switches_details.rate

Rate of context switches.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {switches}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.disk_free

Free disk space on the node.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {bytes} | Sum | Int | Cumulative | false |

### rabbitmq.node.disk_free_alarm

Whether disk usage has triggered an alarm.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {status} | Sum | Int | Cumulative | false |

### rabbitmq.node.disk_free_details.rate

Rate of disk usage change.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {bytes}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.disk_free_limit

Minimum required free disk space before alarm.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {bytes} | Sum | Int | Cumulative | false |

### rabbitmq.node.fd_total

Maximum number of file descriptors available.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {fd} | Sum | Int | Cumulative | false |

### rabbitmq.node.fd_used

Number of file descriptors used.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {fd} | Sum | Int | Cumulative | false |

### rabbitmq.node.fd_used_details.rate

Rate of file descriptor usage.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {fd}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.gc_bytes_reclaimed

Bytes reclaimed by garbage collection.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {bytes} | Sum | Int | Cumulative | false |

### rabbitmq.node.gc_bytes_reclaimed_details.rate

Rate of bytes reclaimed by GC.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {bytes}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.gc_num

Number of garbage collections.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {collections} | Sum | Int | Cumulative | false |

### rabbitmq.node.gc_num_details.rate

Rate of garbage collections.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {collections}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.io_read_avg_time

Average read time in microseconds.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {microseconds} | Sum | Double | Cumulative | false |

### rabbitmq.node.io_read_avg_time_details.rate

Rate of change of average read time.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {microseconds}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.io_read_bytes

Total bytes read.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {bytes} | Sum | Int | Cumulative | false |

### rabbitmq.node.io_read_bytes_details.rate

Rate of bytes read.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {bytes}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.io_read_count

Number of read operations.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops} | Sum | Int | Cumulative | false |

### rabbitmq.node.io_read_count_details.rate

Rate of read operations.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.io_reopen_count

Number of file reopen operations.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops} | Sum | Int | Cumulative | false |

### rabbitmq.node.io_reopen_count_details.rate

Rate of file reopen operations.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.io_seek_avg_time

Average seek time in microseconds.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {microseconds} | Sum | Double | Cumulative | false |

### rabbitmq.node.io_seek_avg_time_details.rate

Rate of change of average seek time.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {microseconds}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.io_seek_count

Number of seek operations.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops} | Sum | Int | Cumulative | false |

### rabbitmq.node.io_seek_count_details.rate

Rate of seek operations.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.io_sync_avg_time

Average sync time in microseconds.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {microseconds} | Sum | Double | Cumulative | false |

### rabbitmq.node.io_sync_avg_time_details.rate

Rate of change of average sync time.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {microseconds}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.io_sync_count

Number of sync operations.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops} | Sum | Int | Cumulative | false |

### rabbitmq.node.io_sync_count_details.rate

Rate of sync operations.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.io_write_avg_time

Average write time in microseconds.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {microseconds} | Sum | Double | Cumulative | false |

### rabbitmq.node.io_write_avg_time_details.rate

Rate of change of average write time.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {microseconds}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.io_write_bytes

Total bytes written.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {bytes} | Sum | Int | Cumulative | false |

### rabbitmq.node.io_write_bytes_details.rate

Rate of bytes written.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {bytes}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.io_write_count

Number of write operations.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops} | Sum | Int | Cumulative | false |

### rabbitmq.node.io_write_count_details.rate

Rate of write operations.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.mem_alarm

Whether memory alarm is triggered.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {status} | Sum | Int | Cumulative | false |

### rabbitmq.node.mem_limit

The memory limit on the node.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {bytes} | Sum | Int | Cumulative | false |

### rabbitmq.node.mem_used

The memory used on the node.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {bytes} | Sum | Int | Cumulative | false |

### rabbitmq.node.mem_used_details.rate

Rate of memory usage change.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {bytes}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.mnesia_disk_tx_count

Number of disk transactions in Mnesia.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {tx} | Sum | Int | Cumulative | false |

### rabbitmq.node.mnesia_disk_tx_count_details.rate

Rate of disk transactions in Mnesia.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {tx}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.mnesia_ram_tx_count

Number of RAM transactions in Mnesia.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {tx} | Sum | Int | Cumulative | false |

### rabbitmq.node.mnesia_ram_tx_count_details.rate

Rate of RAM transactions in Mnesia.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {tx}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.msg_store_read_count

Number of message store reads.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops} | Sum | Int | Cumulative | false |

### rabbitmq.node.msg_store_read_count_details.rate

Rate of message store reads.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.msg_store_write_count

Number of message store writes.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops} | Sum | Int | Cumulative | false |

### rabbitmq.node.msg_store_write_count_details.rate

Rate of message store writes.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.proc_total

Maximum allowed Erlang processes.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {processes} | Sum | Int | Cumulative | false |

### rabbitmq.node.proc_used

Number of Erlang processes in use.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {processes} | Sum | Int | Cumulative | false |

### rabbitmq.node.proc_used_details.rate

Rate of process usage.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {processes}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.processors

Number of processors available to the node.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {processors} | Sum | Int | Cumulative | false |

### rabbitmq.node.queue_created

Number of queues created.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {queues} | Sum | Int | Cumulative | false |

### rabbitmq.node.queue_created_details.rate

Rate of queues created.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {queues}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.queue_declared

Number of queues declared.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {queues} | Sum | Int | Cumulative | false |

### rabbitmq.node.queue_declared_details.rate

Rate of queues declared.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {queues}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.queue_deleted

Number of queues deleted.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {queues} | Sum | Int | Cumulative | false |

### rabbitmq.node.queue_deleted_details.rate

Rate of queues deleted.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {queues}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.queue_index_read_count

Number of queue index reads.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops} | Sum | Int | Cumulative | false |

### rabbitmq.node.queue_index_read_count_details.rate

Rate of queue index reads.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.queue_index_write_count

Number of queue index writes.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops} | Sum | Int | Cumulative | false |

### rabbitmq.node.queue_index_write_count_details.rate

Rate of queue index writes.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {ops}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.run_queue

Run queue length of the Erlang scheduler.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {threads} | Sum | Int | Cumulative | false |

### rabbitmq.node.sockets_total

Maximum allowed sockets.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {sockets} | Sum | Int | Cumulative | false |

### rabbitmq.node.sockets_used

Number of sockets in use.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {sockets} | Sum | Int | Cumulative | false |

### rabbitmq.node.sockets_used_details.rate

Rate of socket usage.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| {sockets}/s | Sum | Double | Cumulative | false |

### rabbitmq.node.uptime

Uptime of the node.

| Unit | Metric Type | Value Type | Aggregation Temporality | Monotonic |
| ---- | ----------- | ---------- | ----------------------- | --------- |
| ms | Sum | Int | Cumulative | false |

## Resource Attributes

| Name | Description | Values | Enabled |
| ---- | ----------- | ------ | ------- |
| rabbitmq.node.name | The name of the RabbitMQ node. | Any Str | true |
| rabbitmq.queue.name | The name of the RabbitMQ queue. | Any Str | true |
| rabbitmq.vhost.name | The name of the RabbitMQ vHost. | Any Str | true |
