// Code generated by mdatagen. DO NOT EDIT.

package metadata

import (
	"go.opentelemetry.io/collector/confmap"
	"go.opentelemetry.io/collector/filter"
)

// MetricConfig provides common config for a particular metric.
type MetricConfig struct {
	Enabled bool `mapstructure:"enabled"`

	enabledSetByUser bool
}

func (ms *MetricConfig) Unmarshal(parser *confmap.Conf) error {
	if parser == nil {
		return nil
	}
	err := parser.Unmarshal(ms)
	if err != nil {
		return err
	}
	ms.enabledSetByUser = parser.IsSet("enabled")
	return nil
}

// MetricsConfig provides config for sqlserver metrics.
type MetricsConfig struct {
	SqlserverBatchRequestRate                   MetricConfig `mapstructure:"sqlserver.batch.request.rate"`
	SqlserverBatchSQLCompilationRate            MetricConfig `mapstructure:"sqlserver.batch.sql_compilation.rate"`
	SqlserverBatchSQLRecompilationRate          MetricConfig `mapstructure:"sqlserver.batch.sql_recompilation.rate"`
	SqlserverDatabaseBackupOrRestoreRate        MetricConfig `mapstructure:"sqlserver.database.backup_or_restore.rate"`
	SqlserverDatabaseCount                      MetricConfig `mapstructure:"sqlserver.database.count"`
	SqlserverDatabaseExecutionErrors            MetricConfig `mapstructure:"sqlserver.database.execution.errors"`
	SqlserverDatabaseFullScanRate               MetricConfig `mapstructure:"sqlserver.database.full_scan.rate"`
	SqlserverDatabaseIo                         MetricConfig `mapstructure:"sqlserver.database.io"`
	SqlserverDatabaseLatency                    MetricConfig `mapstructure:"sqlserver.database.latency"`
	SqlserverDatabaseOperations                 MetricConfig `mapstructure:"sqlserver.database.operations"`
	SqlserverDatabaseTempdbSpace                MetricConfig `mapstructure:"sqlserver.database.tempdb.space"`
	SqlserverDatabaseTempdbVersionStoreSize     MetricConfig `mapstructure:"sqlserver.database.tempdb.version_store.size"`
	SqlserverDeadlockRate                       MetricConfig `mapstructure:"sqlserver.deadlock.rate"`
	SqlserverIndexSearchRate                    MetricConfig `mapstructure:"sqlserver.index.search.rate"`
	SqlserverLockTimeoutRate                    MetricConfig `mapstructure:"sqlserver.lock.timeout.rate"`
	SqlserverLockWaitCount                      MetricConfig `mapstructure:"sqlserver.lock.wait.count"`
	SqlserverLockWaitRate                       MetricConfig `mapstructure:"sqlserver.lock.wait.rate"`
	SqlserverLockWaitTimeAvg                    MetricConfig `mapstructure:"sqlserver.lock.wait_time.avg"`
	SqlserverLoginRate                          MetricConfig `mapstructure:"sqlserver.login.rate"`
	SqlserverLogoutRate                         MetricConfig `mapstructure:"sqlserver.logout.rate"`
	SqlserverMemoryGrantsPendingCount           MetricConfig `mapstructure:"sqlserver.memory.grants.pending.count"`
	SqlserverMemoryUsage                        MetricConfig `mapstructure:"sqlserver.memory.usage"`
	SqlserverOsWaitDuration                     MetricConfig `mapstructure:"sqlserver.os.wait.duration"`
	SqlserverPageBufferCacheFreeListStallsRate  MetricConfig `mapstructure:"sqlserver.page.buffer_cache.free_list.stalls.rate"`
	SqlserverPageBufferCacheHitRatio            MetricConfig `mapstructure:"sqlserver.page.buffer_cache.hit_ratio"`
	SqlserverPageCheckpointFlushRate            MetricConfig `mapstructure:"sqlserver.page.checkpoint.flush.rate"`
	SqlserverPageLazyWriteRate                  MetricConfig `mapstructure:"sqlserver.page.lazy_write.rate"`
	SqlserverPageLifeExpectancy                 MetricConfig `mapstructure:"sqlserver.page.life_expectancy"`
	SqlserverPageLookupRate                     MetricConfig `mapstructure:"sqlserver.page.lookup.rate"`
	SqlserverPageOperationRate                  MetricConfig `mapstructure:"sqlserver.page.operation.rate"`
	SqlserverPageSplitRate                      MetricConfig `mapstructure:"sqlserver.page.split.rate"`
	SqlserverProcessesBlocked                   MetricConfig `mapstructure:"sqlserver.processes.blocked"`
	SqlserverReplicaDataRate                    MetricConfig `mapstructure:"sqlserver.replica.data.rate"`
	SqlserverResourcePoolDiskOperations         MetricConfig `mapstructure:"sqlserver.resource_pool.disk.operations"`
	SqlserverResourcePoolDiskThrottledReadRate  MetricConfig `mapstructure:"sqlserver.resource_pool.disk.throttled.read.rate"`
	SqlserverResourcePoolDiskThrottledWriteRate MetricConfig `mapstructure:"sqlserver.resource_pool.disk.throttled.write.rate"`
	SqlserverTableCount                         MetricConfig `mapstructure:"sqlserver.table.count"`
	SqlserverTransactionDelay                   MetricConfig `mapstructure:"sqlserver.transaction.delay"`
	SqlserverTransactionMirrorWriteRate         MetricConfig `mapstructure:"sqlserver.transaction.mirror_write.rate"`
	SqlserverTransactionRate                    MetricConfig `mapstructure:"sqlserver.transaction.rate"`
	SqlserverTransactionWriteRate               MetricConfig `mapstructure:"sqlserver.transaction.write.rate"`
	SqlserverTransactionLogFlushDataRate        MetricConfig `mapstructure:"sqlserver.transaction_log.flush.data.rate"`
	SqlserverTransactionLogFlushRate            MetricConfig `mapstructure:"sqlserver.transaction_log.flush.rate"`
	SqlserverTransactionLogFlushWaitRate        MetricConfig `mapstructure:"sqlserver.transaction_log.flush.wait.rate"`
	SqlserverTransactionLogGrowthCount          MetricConfig `mapstructure:"sqlserver.transaction_log.growth.count"`
	SqlserverTransactionLogShrinkCount          MetricConfig `mapstructure:"sqlserver.transaction_log.shrink.count"`
	SqlserverTransactionLogUsage                MetricConfig `mapstructure:"sqlserver.transaction_log.usage"`
	SqlserverUserConnectionCount                MetricConfig `mapstructure:"sqlserver.user.connection.count"`
}

func DefaultMetricsConfig() MetricsConfig {
	return MetricsConfig{
		SqlserverBatchRequestRate: MetricConfig{
			Enabled: true,
		},
		SqlserverBatchSQLCompilationRate: MetricConfig{
			Enabled: true,
		},
		SqlserverBatchSQLRecompilationRate: MetricConfig{
			Enabled: true,
		},
		SqlserverDatabaseBackupOrRestoreRate: MetricConfig{
			Enabled: false,
		},
		SqlserverDatabaseCount: MetricConfig{
			Enabled: false,
		},
		SqlserverDatabaseExecutionErrors: MetricConfig{
			Enabled: false,
		},
		SqlserverDatabaseFullScanRate: MetricConfig{
			Enabled: false,
		},
		SqlserverDatabaseIo: MetricConfig{
			Enabled: false,
		},
		SqlserverDatabaseLatency: MetricConfig{
			Enabled: false,
		},
		SqlserverDatabaseOperations: MetricConfig{
			Enabled: false,
		},
		SqlserverDatabaseTempdbSpace: MetricConfig{
			Enabled: false,
		},
		SqlserverDatabaseTempdbVersionStoreSize: MetricConfig{
			Enabled: false,
		},
		SqlserverDeadlockRate: MetricConfig{
			Enabled: false,
		},
		SqlserverIndexSearchRate: MetricConfig{
			Enabled: false,
		},
		SqlserverLockTimeoutRate: MetricConfig{
			Enabled: false,
		},
		SqlserverLockWaitCount: MetricConfig{
			Enabled: false,
		},
		SqlserverLockWaitRate: MetricConfig{
			Enabled: true,
		},
		SqlserverLockWaitTimeAvg: MetricConfig{
			Enabled: true,
		},
		SqlserverLoginRate: MetricConfig{
			Enabled: false,
		},
		SqlserverLogoutRate: MetricConfig{
			Enabled: false,
		},
		SqlserverMemoryGrantsPendingCount: MetricConfig{
			Enabled: false,
		},
		SqlserverMemoryUsage: MetricConfig{
			Enabled: false,
		},
		SqlserverOsWaitDuration: MetricConfig{
			Enabled: false,
		},
		SqlserverPageBufferCacheFreeListStallsRate: MetricConfig{
			Enabled: false,
		},
		SqlserverPageBufferCacheHitRatio: MetricConfig{
			Enabled: true,
		},
		SqlserverPageCheckpointFlushRate: MetricConfig{
			Enabled: true,
		},
		SqlserverPageLazyWriteRate: MetricConfig{
			Enabled: true,
		},
		SqlserverPageLifeExpectancy: MetricConfig{
			Enabled: true,
		},
		SqlserverPageLookupRate: MetricConfig{
			Enabled: false,
		},
		SqlserverPageOperationRate: MetricConfig{
			Enabled: true,
		},
		SqlserverPageSplitRate: MetricConfig{
			Enabled: true,
		},
		SqlserverProcessesBlocked: MetricConfig{
			Enabled: false,
		},
		SqlserverReplicaDataRate: MetricConfig{
			Enabled: false,
		},
		SqlserverResourcePoolDiskOperations: MetricConfig{
			Enabled: false,
		},
		SqlserverResourcePoolDiskThrottledReadRate: MetricConfig{
			Enabled: false,
		},
		SqlserverResourcePoolDiskThrottledWriteRate: MetricConfig{
			Enabled: false,
		},
		SqlserverTableCount: MetricConfig{
			Enabled: false,
		},
		SqlserverTransactionDelay: MetricConfig{
			Enabled: false,
		},
		SqlserverTransactionMirrorWriteRate: MetricConfig{
			Enabled: false,
		},
		SqlserverTransactionRate: MetricConfig{
			Enabled: true,
		},
		SqlserverTransactionWriteRate: MetricConfig{
			Enabled: true,
		},
		SqlserverTransactionLogFlushDataRate: MetricConfig{
			Enabled: true,
		},
		SqlserverTransactionLogFlushRate: MetricConfig{
			Enabled: true,
		},
		SqlserverTransactionLogFlushWaitRate: MetricConfig{
			Enabled: true,
		},
		SqlserverTransactionLogGrowthCount: MetricConfig{
			Enabled: true,
		},
		SqlserverTransactionLogShrinkCount: MetricConfig{
			Enabled: true,
		},
		SqlserverTransactionLogUsage: MetricConfig{
			Enabled: true,
		},
		SqlserverUserConnectionCount: MetricConfig{
			Enabled: true,
		},
	}
}

// EventConfig provides common config for a particular event.
type EventConfig struct {
	Enabled bool `mapstructure:"enabled"`

	enabledSetByUser bool
}

func (ec *EventConfig) Unmarshal(parser *confmap.Conf) error {
	if parser == nil {
		return nil
	}
	err := parser.Unmarshal(ec)
	if err != nil {
		return err
	}
	ec.enabledSetByUser = parser.IsSet("enabled")
	return nil
}

// EventsConfig provides config for sqlserver events.
type EventsConfig struct {
	DbServerQuerySample EventConfig `mapstructure:"db.server.query_sample"`
	DbServerTopQuery    EventConfig `mapstructure:"db.server.top_query"`
}

func DefaultEventsConfig() EventsConfig {
	return EventsConfig{
		DbServerQuerySample: EventConfig{
			Enabled: true,
		},
		DbServerTopQuery: EventConfig{
			Enabled: true,
		},
	}
}

// ResourceAttributeConfig provides common config for a particular resource attribute.
type ResourceAttributeConfig struct {
	Enabled bool `mapstructure:"enabled"`
	// Experimental: MetricsInclude defines a list of filters for attribute values.
	// If the list is not empty, only metrics with matching resource attribute values will be emitted.
	MetricsInclude []filter.Config `mapstructure:"metrics_include"`
	// Experimental: MetricsExclude defines a list of filters for attribute values.
	// If the list is not empty, metrics with matching resource attribute values will not be emitted.
	// MetricsInclude has higher priority than MetricsExclude.
	MetricsExclude []filter.Config `mapstructure:"metrics_exclude"`
	// Experimental: EventsInclude defines a list of filters for attribute values.
	// If the list is not empty, only events with matching resource attribute values will be emitted.
	EventsInclude []filter.Config `mapstructure:"events_include"`
	// Experimental: EventsExclude defines a list of filters for attribute values.
	// If the list is not empty, events with matching resource attribute values will not be emitted.
	// EventsInclude has higher priority than EventsExclude.
	EventsExclude []filter.Config `mapstructure:"events_exclude"`

	enabledSetByUser bool
}

func (rac *ResourceAttributeConfig) Unmarshal(parser *confmap.Conf) error {
	if parser == nil {
		return nil
	}
	err := parser.Unmarshal(rac)
	if err != nil {
		return err
	}
	rac.enabledSetByUser = parser.IsSet("enabled")
	return nil
}

// ResourceAttributesConfig provides config for sqlserver resource attributes.
type ResourceAttributesConfig struct {
	HostName              ResourceAttributeConfig `mapstructure:"host.name"`
	ServerAddress         ResourceAttributeConfig `mapstructure:"server.address"`
	ServerPort            ResourceAttributeConfig `mapstructure:"server.port"`
	SqlserverComputerName ResourceAttributeConfig `mapstructure:"sqlserver.computer.name"`
	SqlserverDatabaseName ResourceAttributeConfig `mapstructure:"sqlserver.database.name"`
	SqlserverInstanceName ResourceAttributeConfig `mapstructure:"sqlserver.instance.name"`
}

func DefaultResourceAttributesConfig() ResourceAttributesConfig {
	return ResourceAttributesConfig{
		HostName: ResourceAttributeConfig{
			Enabled: true,
		},
		ServerAddress: ResourceAttributeConfig{
			Enabled: false,
		},
		ServerPort: ResourceAttributeConfig{
			Enabled: false,
		},
		SqlserverComputerName: ResourceAttributeConfig{
			Enabled: false,
		},
		SqlserverDatabaseName: ResourceAttributeConfig{
			Enabled: true,
		},
		SqlserverInstanceName: ResourceAttributeConfig{
			Enabled: false,
		},
	}
}

// MetricsBuilderConfig is a configuration for sqlserver metrics builder.
type MetricsBuilderConfig struct {
	Metrics            MetricsConfig            `mapstructure:"metrics"`
	ResourceAttributes ResourceAttributesConfig `mapstructure:"resource_attributes"`
}

func DefaultMetricsBuilderConfig() MetricsBuilderConfig {
	return MetricsBuilderConfig{
		Metrics:            DefaultMetricsConfig(),
		ResourceAttributes: DefaultResourceAttributesConfig(),
	}
}

// LogsBuilderConfig is a configuration for sqlserver logs builder.
type LogsBuilderConfig struct {
	Events             EventsConfig             `mapstructure:"events"`
	ResourceAttributes ResourceAttributesConfig `mapstructure:"resource_attributes"`
}

func DefaultLogsBuilderConfig() LogsBuilderConfig {
	return LogsBuilderConfig{
		Events:             DefaultEventsConfig(),
		ResourceAttributes: DefaultResourceAttributesConfig(),
	}
}
