# STEF Receiver

<!-- status autogenerated section -->
| Status        |           |
| ------------- |-----------|
| Stability     | [alpha]: metrics   |
| Distributions | [contrib] |
| Issues        | [![Open issues](https://img.shields.io/github/issues-search/open-telemetry/opentelemetry-collector-contrib?query=is%3Aissue%20is%3Aopen%20label%3Areceiver%2Fstef%20&label=open&color=orange&logo=opentelemetry)](https://github.com/open-telemetry/opentelemetry-collector-contrib/issues?q=is%3Aopen+is%3Aissue+label%3Areceiver%2Fstef) [![Closed issues](https://img.shields.io/github/issues-search/open-telemetry/opentelemetry-collector-contrib?query=is%3Aissue%20is%3Aclosed%20label%3Areceiver%2Fstef%20&label=closed&color=blue&logo=opentelemetry)](https://github.com/open-telemetry/opentelemetry-collector-contrib/issues?q=is%3Aclosed+is%3Aissue+label%3Areceiver%2Fstef) |
| Code coverage | [![codecov](https://codecov.io/github/open-telemetry/opentelemetry-collector-contrib/graph/main/badge.svg?component=receiver_stef)](https://app.codecov.io/gh/open-telemetry/opentelemetry-collector-contrib/tree/main/?components%5B0%5D=receiver_stef&displayType=list) |
| [Code Owners](https://github.com/open-telemetry/opentelemetry-collector-contrib/blob/main/CONTRIBUTING.md#becoming-a-code-owner)    | [@tigrannajaryan](https://www.github.com/tigrannajaryan), [@MovieStoreGuy](https://www.github.com/MovieStoreGuy), [@dmitryax](https://www.github.com/dmitryax), [@atoulme](https://www.github.com/atoulme), [@pjanotti](https://www.github.com/pjanotti), [@crobert-1](https://www.github.com/crobert-1) |

[alpha]: https://github.com/open-telemetry/opentelemetry-collector/blob/main/docs/component-stability.md#alpha
[contrib]: https://github.com/open-telemetry/opentelemetry-collector-releases/tree/main/distributions/otelcol-contrib
<!-- end autogenerated section -->

Receives data via gRPC in Otel/STEF format. Otel/STEF is a compact and
fast telemetry format. For more about Otel/STEF, see
[STEF exporter docs](../../exporter/stefexporter/README.md).

## Configuration

- `endpoint` (default = localhost:4320 for grpc protocol):
  host:port on which the receiver is going to receive data. Refer to
  [naming documentation](https://github.com/grpc/grpc/blob/master/doc/naming.md)
  for valid syntax for host part.
- `ack_interval` (default: 10ms). The periodical interval of time when sending acknowledgements back to the client.

Example:

```yaml
stef:
  endpoint: 0.0.0.0:4320
```

STEF receiver supports the following advanced settings:

- [gRPC settings](https://github.com/open-telemetry/opentelemetry-collector/blob/main/config/configgrpc/README.md)
- [TLS and mTLS settings](https://github.com/open-telemetry/opentelemetry-collector/blob/main/config/configtls/README.md)