// Code generated by mdatagen. DO NOT EDIT.

package metadata

import (
	"time"

	"go.opentelemetry.io/collector/component"
	"go.opentelemetry.io/collector/pdata/pcommon"
	"go.opentelemetry.io/collector/pdata/pmetric"
	"go.opentelemetry.io/collector/receiver"
)

// AttributeErrorCode specifies the value error.code attribute.
type AttributeErrorCode int

const (
	_ AttributeErrorCode = iota
	AttributeErrorCodeConnectionRefused
	AttributeErrorCodeConnectionTimeout
	AttributeErrorCodeInvalidEndpoint
	AttributeErrorCodeNetworkUnreachable
	AttributeErrorCodeUnknownError
)

// String returns the string representation of the AttributeErrorCode.
func (av AttributeErrorCode) String() string {
	switch av {
	case AttributeErrorCodeConnectionRefused:
		return "connection_refused"
	case AttributeErrorCodeConnectionTimeout:
		return "connection_timeout"
	case AttributeErrorCodeInvalidEndpoint:
		return "invalid_endpoint"
	case AttributeErrorCodeNetworkUnreachable:
		return "network_unreachable"
	case AttributeErrorCodeUnknownError:
		return "unknown_error"
	}
	return ""
}

// MapAttributeErrorCode is a helper map of string to AttributeErrorCode attribute value.
var MapAttributeErrorCode = map[string]AttributeErrorCode{
	"connection_refused":  AttributeErrorCodeConnectionRefused,
	"connection_timeout":  AttributeErrorCodeConnectionTimeout,
	"invalid_endpoint":    AttributeErrorCodeInvalidEndpoint,
	"network_unreachable": AttributeErrorCodeNetworkUnreachable,
	"unknown_error":       AttributeErrorCodeUnknownError,
}

var MetricsInfo = metricsInfo{
	TcpcheckDuration: metricInfo{
		Name: "tcpcheck.duration",
	},
	TcpcheckError: metricInfo{
		Name: "tcpcheck.error",
	},
	TcpcheckStatus: metricInfo{
		Name: "tcpcheck.status",
	},
}

type metricsInfo struct {
	TcpcheckDuration metricInfo
	TcpcheckError    metricInfo
	TcpcheckStatus   metricInfo
}

type metricInfo struct {
	Name string
}

type metricTcpcheckDuration struct {
	data     pmetric.Metric // data buffer for generated metric.
	config   MetricConfig   // metric config provided by user.
	capacity int            // max observed number of data points added to the metric.
}

// init fills tcpcheck.duration metric with initial data.
func (m *metricTcpcheckDuration) init() {
	m.data.SetName("tcpcheck.duration")
	m.data.SetDescription("Measures the duration of TCP connection.")
	m.data.SetUnit("ms")
	m.data.SetEmptyGauge()
	m.data.Gauge().DataPoints().EnsureCapacity(m.capacity)
}

func (m *metricTcpcheckDuration) recordDataPoint(start pcommon.Timestamp, ts pcommon.Timestamp, val int64, tcpcheckEndpointAttributeValue string) {
	if !m.config.Enabled {
		return
	}
	dp := m.data.Gauge().DataPoints().AppendEmpty()
	dp.SetStartTimestamp(start)
	dp.SetTimestamp(ts)
	dp.SetIntValue(val)
	dp.Attributes().PutStr("tcpcheck.endpoint", tcpcheckEndpointAttributeValue)
}

// updateCapacity saves max length of data point slices that will be used for the slice capacity.
func (m *metricTcpcheckDuration) updateCapacity() {
	if m.data.Gauge().DataPoints().Len() > m.capacity {
		m.capacity = m.data.Gauge().DataPoints().Len()
	}
}

// emit appends recorded metric data to a metrics slice and prepares it for recording another set of data points.
func (m *metricTcpcheckDuration) emit(metrics pmetric.MetricSlice) {
	if m.config.Enabled && m.data.Gauge().DataPoints().Len() > 0 {
		m.updateCapacity()
		m.data.MoveTo(metrics.AppendEmpty())
		m.init()
	}
}

func newMetricTcpcheckDuration(cfg MetricConfig) metricTcpcheckDuration {
	m := metricTcpcheckDuration{config: cfg}
	if cfg.Enabled {
		m.data = pmetric.NewMetric()
		m.init()
	}
	return m
}

type metricTcpcheckError struct {
	data     pmetric.Metric // data buffer for generated metric.
	config   MetricConfig   // metric config provided by user.
	capacity int            // max observed number of data points added to the metric.
}

// init fills tcpcheck.error metric with initial data.
func (m *metricTcpcheckError) init() {
	m.data.SetName("tcpcheck.error")
	m.data.SetDescription("Records errors occurring during TCP check.")
	m.data.SetUnit("{error}")
	m.data.SetEmptySum()
	m.data.Sum().SetIsMonotonic(true)
	m.data.Sum().SetAggregationTemporality(pmetric.AggregationTemporalityCumulative)
	m.data.Sum().DataPoints().EnsureCapacity(m.capacity)
}

func (m *metricTcpcheckError) recordDataPoint(start pcommon.Timestamp, ts pcommon.Timestamp, val int64, tcpcheckEndpointAttributeValue string, errorCodeAttributeValue string) {
	if !m.config.Enabled {
		return
	}
	dp := m.data.Sum().DataPoints().AppendEmpty()
	dp.SetStartTimestamp(start)
	dp.SetTimestamp(ts)
	dp.SetIntValue(val)
	dp.Attributes().PutStr("tcpcheck.endpoint", tcpcheckEndpointAttributeValue)
	dp.Attributes().PutStr("error.code", errorCodeAttributeValue)
}

// updateCapacity saves max length of data point slices that will be used for the slice capacity.
func (m *metricTcpcheckError) updateCapacity() {
	if m.data.Sum().DataPoints().Len() > m.capacity {
		m.capacity = m.data.Sum().DataPoints().Len()
	}
}

// emit appends recorded metric data to a metrics slice and prepares it for recording another set of data points.
func (m *metricTcpcheckError) emit(metrics pmetric.MetricSlice) {
	if m.config.Enabled && m.data.Sum().DataPoints().Len() > 0 {
		m.updateCapacity()
		m.data.MoveTo(metrics.AppendEmpty())
		m.init()
	}
}

func newMetricTcpcheckError(cfg MetricConfig) metricTcpcheckError {
	m := metricTcpcheckError{config: cfg}
	if cfg.Enabled {
		m.data = pmetric.NewMetric()
		m.init()
	}
	return m
}

type metricTcpcheckStatus struct {
	data     pmetric.Metric // data buffer for generated metric.
	config   MetricConfig   // metric config provided by user.
	capacity int            // max observed number of data points added to the metric.
}

// init fills tcpcheck.status metric with initial data.
func (m *metricTcpcheckStatus) init() {
	m.data.SetName("tcpcheck.status")
	m.data.SetDescription("1 if the TCP client successfully connected, otherwise 0.")
	m.data.SetUnit("1")
	m.data.SetEmptyGauge()
	m.data.Gauge().DataPoints().EnsureCapacity(m.capacity)
}

func (m *metricTcpcheckStatus) recordDataPoint(start pcommon.Timestamp, ts pcommon.Timestamp, val int64, tcpcheckEndpointAttributeValue string) {
	if !m.config.Enabled {
		return
	}
	dp := m.data.Gauge().DataPoints().AppendEmpty()
	dp.SetStartTimestamp(start)
	dp.SetTimestamp(ts)
	dp.SetIntValue(val)
	dp.Attributes().PutStr("tcpcheck.endpoint", tcpcheckEndpointAttributeValue)
}

// updateCapacity saves max length of data point slices that will be used for the slice capacity.
func (m *metricTcpcheckStatus) updateCapacity() {
	if m.data.Gauge().DataPoints().Len() > m.capacity {
		m.capacity = m.data.Gauge().DataPoints().Len()
	}
}

// emit appends recorded metric data to a metrics slice and prepares it for recording another set of data points.
func (m *metricTcpcheckStatus) emit(metrics pmetric.MetricSlice) {
	if m.config.Enabled && m.data.Gauge().DataPoints().Len() > 0 {
		m.updateCapacity()
		m.data.MoveTo(metrics.AppendEmpty())
		m.init()
	}
}

func newMetricTcpcheckStatus(cfg MetricConfig) metricTcpcheckStatus {
	m := metricTcpcheckStatus{config: cfg}
	if cfg.Enabled {
		m.data = pmetric.NewMetric()
		m.init()
	}
	return m
}

// MetricsBuilder provides an interface for scrapers to report metrics while taking care of all the transformations
// required to produce metric representation defined in metadata and user config.
type MetricsBuilder struct {
	config                 MetricsBuilderConfig // config of the metrics builder.
	startTime              pcommon.Timestamp    // start time that will be applied to all recorded data points.
	metricsCapacity        int                  // maximum observed number of metrics per resource.
	metricsBuffer          pmetric.Metrics      // accumulates metrics data before emitting.
	buildInfo              component.BuildInfo  // contains version information.
	metricTcpcheckDuration metricTcpcheckDuration
	metricTcpcheckError    metricTcpcheckError
	metricTcpcheckStatus   metricTcpcheckStatus
}

// MetricBuilderOption applies changes to default metrics builder.
type MetricBuilderOption interface {
	apply(*MetricsBuilder)
}

type metricBuilderOptionFunc func(mb *MetricsBuilder)

func (mbof metricBuilderOptionFunc) apply(mb *MetricsBuilder) {
	mbof(mb)
}

// WithStartTime sets startTime on the metrics builder.
func WithStartTime(startTime pcommon.Timestamp) MetricBuilderOption {
	return metricBuilderOptionFunc(func(mb *MetricsBuilder) {
		mb.startTime = startTime
	})
}
func NewMetricsBuilder(mbc MetricsBuilderConfig, settings receiver.Settings, options ...MetricBuilderOption) *MetricsBuilder {
	mb := &MetricsBuilder{
		config:                 mbc,
		startTime:              pcommon.NewTimestampFromTime(time.Now()),
		metricsBuffer:          pmetric.NewMetrics(),
		buildInfo:              settings.BuildInfo,
		metricTcpcheckDuration: newMetricTcpcheckDuration(mbc.Metrics.TcpcheckDuration),
		metricTcpcheckError:    newMetricTcpcheckError(mbc.Metrics.TcpcheckError),
		metricTcpcheckStatus:   newMetricTcpcheckStatus(mbc.Metrics.TcpcheckStatus),
	}

	for _, op := range options {
		op.apply(mb)
	}
	return mb
}

// updateCapacity updates max length of metrics and resource attributes that will be used for the slice capacity.
func (mb *MetricsBuilder) updateCapacity(rm pmetric.ResourceMetrics) {
	if mb.metricsCapacity < rm.ScopeMetrics().At(0).Metrics().Len() {
		mb.metricsCapacity = rm.ScopeMetrics().At(0).Metrics().Len()
	}
}

// ResourceMetricsOption applies changes to provided resource metrics.
type ResourceMetricsOption interface {
	apply(pmetric.ResourceMetrics)
}

type resourceMetricsOptionFunc func(pmetric.ResourceMetrics)

func (rmof resourceMetricsOptionFunc) apply(rm pmetric.ResourceMetrics) {
	rmof(rm)
}

// WithResource sets the provided resource on the emitted ResourceMetrics.
// It's recommended to use ResourceBuilder to create the resource.
func WithResource(res pcommon.Resource) ResourceMetricsOption {
	return resourceMetricsOptionFunc(func(rm pmetric.ResourceMetrics) {
		res.CopyTo(rm.Resource())
	})
}

// WithStartTimeOverride overrides start time for all the resource metrics data points.
// This option should be only used if different start time has to be set on metrics coming from different resources.
func WithStartTimeOverride(start pcommon.Timestamp) ResourceMetricsOption {
	return resourceMetricsOptionFunc(func(rm pmetric.ResourceMetrics) {
		var dps pmetric.NumberDataPointSlice
		metrics := rm.ScopeMetrics().At(0).Metrics()
		for i := 0; i < metrics.Len(); i++ {
			switch metrics.At(i).Type() {
			case pmetric.MetricTypeGauge:
				dps = metrics.At(i).Gauge().DataPoints()
			case pmetric.MetricTypeSum:
				dps = metrics.At(i).Sum().DataPoints()
			}
			for j := 0; j < dps.Len(); j++ {
				dps.At(j).SetStartTimestamp(start)
			}
		}
	})
}

// EmitForResource saves all the generated metrics under a new resource and updates the internal state to be ready for
// recording another set of data points as part of another resource. This function can be helpful when one scraper
// needs to emit metrics from several resources. Otherwise calling this function is not required,
// just `Emit` function can be called instead.
// Resource attributes should be provided as ResourceMetricsOption arguments.
func (mb *MetricsBuilder) EmitForResource(options ...ResourceMetricsOption) {
	rm := pmetric.NewResourceMetrics()
	ils := rm.ScopeMetrics().AppendEmpty()
	ils.Scope().SetName(ScopeName)
	ils.Scope().SetVersion(mb.buildInfo.Version)
	ils.Metrics().EnsureCapacity(mb.metricsCapacity)
	mb.metricTcpcheckDuration.emit(ils.Metrics())
	mb.metricTcpcheckError.emit(ils.Metrics())
	mb.metricTcpcheckStatus.emit(ils.Metrics())

	for _, op := range options {
		op.apply(rm)
	}

	if ils.Metrics().Len() > 0 {
		mb.updateCapacity(rm)
		rm.MoveTo(mb.metricsBuffer.ResourceMetrics().AppendEmpty())
	}
}

// Emit returns all the metrics accumulated by the metrics builder and updates the internal state to be ready for
// recording another set of metrics. This function will be responsible for applying all the transformations required to
// produce metric representation defined in metadata and user config, e.g. delta or cumulative.
func (mb *MetricsBuilder) Emit(options ...ResourceMetricsOption) pmetric.Metrics {
	mb.EmitForResource(options...)
	metrics := mb.metricsBuffer
	mb.metricsBuffer = pmetric.NewMetrics()
	return metrics
}

// RecordTcpcheckDurationDataPoint adds a data point to tcpcheck.duration metric.
func (mb *MetricsBuilder) RecordTcpcheckDurationDataPoint(ts pcommon.Timestamp, val int64, tcpcheckEndpointAttributeValue string) {
	mb.metricTcpcheckDuration.recordDataPoint(mb.startTime, ts, val, tcpcheckEndpointAttributeValue)
}

// RecordTcpcheckErrorDataPoint adds a data point to tcpcheck.error metric.
func (mb *MetricsBuilder) RecordTcpcheckErrorDataPoint(ts pcommon.Timestamp, val int64, tcpcheckEndpointAttributeValue string, errorCodeAttributeValue AttributeErrorCode) {
	mb.metricTcpcheckError.recordDataPoint(mb.startTime, ts, val, tcpcheckEndpointAttributeValue, errorCodeAttributeValue.String())
}

// RecordTcpcheckStatusDataPoint adds a data point to tcpcheck.status metric.
func (mb *MetricsBuilder) RecordTcpcheckStatusDataPoint(ts pcommon.Timestamp, val int64, tcpcheckEndpointAttributeValue string) {
	mb.metricTcpcheckStatus.recordDataPoint(mb.startTime, ts, val, tcpcheckEndpointAttributeValue)
}

// Reset resets metrics builder to its initial state. It should be used when external metrics source is restarted,
// and metrics builder should update its startTime and reset it's internal state accordingly.
func (mb *MetricsBuilder) Reset(options ...MetricBuilderOption) {
	mb.startTime = pcommon.NewTimestampFromTime(time.Now())
	for _, op := range options {
		op.apply(mb)
	}
}
